"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = createClass;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classPrivateFieldLooseBase2 = _interopRequireDefault(require("@babel/runtime/helpers/classPrivateFieldLooseBase"));

var _classPrivateFieldLooseKey2 = _interopRequireDefault(require("@babel/runtime/helpers/classPrivateFieldLooseKey"));

var _rxjs = require("rxjs");

var _operators = require("rxjs/operators");

var _util = require("@polkadot/util");

var _util2 = require("../util");

var _Result = _interopRequireDefault(require("./Result"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

// The default for 6s allowing for 5min eras. When translating this to faster blocks -
//   - 4s = (10 / 15) * 5 = 3.33m
//   - 2s = (10 / 30) * 5 = 1.66m
const BLOCKTIME = 6;
const ONE_MINUTE = 60 / BLOCKTIME;
const DEFAULT_MORTAL_LENGTH = 5 * ONE_MINUTE;

function createClass({
  api,
  apiType,
  decorateMethod
}) {
  var _temp, _ignoreStatusCb, _getPrelimState, _makeEraOptions, _makeSignOptions, _makeSignAndSendOptions, _observeSign, _observeStatus, _observeSend, _observeSubscribe, _optionsOrNonce, _signViaSigner, _updateSigner;

  // an instance of the base extrinsic for us to extend
  const ExtrinsicBase = api.registry.createClass('Extrinsic');
  return _temp = class Submittable extends ExtrinsicBase {
    constructor(registry, extrinsic) {
      super(registry, extrinsic, {
        version: api.extrinsicType
      });
      Object.defineProperty(this, _ignoreStatusCb, {
        writable: true,
        value: void 0
      });
      Object.defineProperty(this, _getPrelimState, {
        writable: true,
        value: (address, options) => {
          return (0, _rxjs.combineLatest)([// if we have a nonce already, don't retrieve the latest, use what is there
          (0, _util.isUndefined)(options.nonce) ? api.derive.balances.account(address).pipe((0, _operators.map)(({
            accountNonce
          }) => accountNonce)) : (0, _rxjs.of)(this.registry.createType('Index', options.nonce)), // if we have an era provided already or eraLength is <= 0 (immortal)
          // don't get the latest block, just pass null, handle in mergeMap
          (0, _util.isUndefined)(options.era) || (0, _util.isNumber)(options.era) && options.era > 0 ? api.rpc.chain.getHeader() : (0, _rxjs.of)(null)]);
        }
      });
      Object.defineProperty(this, _makeEraOptions, {
        writable: true,
        value: (options, {
          header,
          nonce
        }) => {
          if (!header) {
            if ((0, _util.isNumber)(options.era)) {
              // since we have no header, it is immortal, remove any option overrides
              // so we only supply the genesisHash and no era to the construction
              delete options.era;
              delete options.blockHash;
            }

            return (0, _classPrivateFieldLooseBase2.default)(this, _makeSignOptions)[_makeSignOptions](options, {
              nonce
            });
          }

          return (0, _classPrivateFieldLooseBase2.default)(this, _makeSignOptions)[_makeSignOptions](options, {
            blockHash: header.hash,
            era: this.registry.createType('ExtrinsicEra', {
              current: header.number,
              period: options.era || DEFAULT_MORTAL_LENGTH
            }),
            nonce
          });
        }
      });
      Object.defineProperty(this, _makeSignOptions, {
        writable: true,
        value: (options, extras) => {
          return _objectSpread({
            blockHash: api.genesisHash,
            genesisHash: api.genesisHash
          }, options, {}, extras, {
            runtimeVersion: api.runtimeVersion,
            version: api.extrinsicType
          });
        }
      });
      Object.defineProperty(this, _makeSignAndSendOptions, {
        writable: true,
        value: (optionsOrStatus, statusCb) => {
          let options = {};

          if ((0, _util.isFunction)(optionsOrStatus)) {
            statusCb = optionsOrStatus;
          } else {
            options = _objectSpread({}, optionsOrStatus);
          }

          return [options, statusCb];
        }
      });
      Object.defineProperty(this, _observeSign, {
        writable: true,
        value: (account, optionsOrNonce) => {
          const address = (0, _util2.isKeyringPair)(account) ? account.address : account.toString();

          const options = (0, _classPrivateFieldLooseBase2.default)(this, _optionsOrNonce)[_optionsOrNonce](optionsOrNonce);

          let updateId;
          return (0, _classPrivateFieldLooseBase2.default)(this, _getPrelimState)[_getPrelimState](address, options).pipe((0, _operators.first)(), (0, _operators.mergeMap)(async ([nonce, header]) => {
            const eraOptions = (0, _classPrivateFieldLooseBase2.default)(this, _makeEraOptions)[_makeEraOptions](options, {
              header,
              nonce
            });

            if ((0, _util2.isKeyringPair)(account)) {
              this.sign(account, eraOptions);
            } else {
              updateId = await (0, _classPrivateFieldLooseBase2.default)(this, _signViaSigner)[_signViaSigner](address, eraOptions, header);
            }
          }), (0, _operators.mapTo)(updateId));
        }
      });
      Object.defineProperty(this, _observeStatus, {
        writable: true,
        value: status => {
          if (!status.isFinalized && !status.isInBlock) {
            return (0, _rxjs.of)(new _Result.default({
              status
            }));
          }

          const blockHash = status.isInBlock ? status.asInBlock : status.asFinalized;
          return (0, _rxjs.combineLatest)([api.rpc.chain.getBlock(blockHash), api.query.system.events.at(blockHash)]).pipe((0, _operators.map)(([signedBlock, allEvents]) => new _Result.default({
            events: (0, _util2.filterEvents)(this.hash, signedBlock, allEvents, status),
            status
          })));
        }
      });
      Object.defineProperty(this, _observeSend, {
        writable: true,
        value: (updateId = -1) => {
          return api.rpc.author.submitExtrinsic(this).pipe((0, _operators.tap)(hash => {
            (0, _classPrivateFieldLooseBase2.default)(this, _updateSigner)[_updateSigner](updateId, hash);
          }));
        }
      });
      Object.defineProperty(this, _observeSubscribe, {
        writable: true,
        value: (updateId = -1) => {
          return api.rpc.author.submitAndWatchExtrinsic(this).pipe((0, _operators.switchMap)(status => (0, _classPrivateFieldLooseBase2.default)(this, _observeStatus)[_observeStatus](status)), (0, _operators.tap)(status => {
            (0, _classPrivateFieldLooseBase2.default)(this, _updateSigner)[_updateSigner](updateId, status);
          }));
        }
      });
      Object.defineProperty(this, _optionsOrNonce, {
        writable: true,
        value: optionsOrNonce => {
          return (0, _util.isBn)(optionsOrNonce) || (0, _util.isNumber)(optionsOrNonce) ? {
            nonce: optionsOrNonce
          } : optionsOrNonce;
        }
      });
      Object.defineProperty(this, _signViaSigner, {
        writable: true,
        value: async (address, options, header) => {
          const signer = options.signer || api.signer;
          (0, _util.assert)(signer, 'No signer specified, either via api.setSigner or via sign options');
          const payload = this.registry.createType('SignerPayload', _objectSpread({}, options, {
            address,
            method: this.method,
            blockNumber: header ? header.number : 0
          }));
          let result;

          if (signer.signPayload) {
            result = await signer.signPayload(payload.toPayload());
          } else if (signer.signRaw) {
            result = await signer.signRaw(payload.toRaw());
          } else {
            throw new Error('Invalid signer interface, it should implement either signPayload or signRaw (or both)');
          } // Here we explicitly call `toPayload()` again instead of working with an object
          // (reference) as passed to the signer. This means that we are sure that the
          // payload data is not modified from our inputs, but the signer


          super.addSignature(address, result.signature, payload.toPayload());
          return result.id;
        }
      });
      Object.defineProperty(this, _updateSigner, {
        writable: true,
        value: (updateId, status) => {
          if (updateId !== -1 && api.signer && api.signer.update) {
            api.signer.update(updateId, status);
          }
        }
      });
      (0, _classPrivateFieldLooseBase2.default)(this, _ignoreStatusCb)[_ignoreStatusCb] = apiType === 'rxjs';
    } // calculate the payment info for this transaction (if signed and submitted)


    paymentInfo(account, options) {
      const [allOptions] = (0, _classPrivateFieldLooseBase2.default)(this, _makeSignAndSendOptions)[_makeSignAndSendOptions](options);

      const address = (0, _util2.isKeyringPair)(account) ? account.address : account.toString();
      return decorateMethod(() => (0, _classPrivateFieldLooseBase2.default)(this, _getPrelimState)[_getPrelimState](address, allOptions).pipe((0, _operators.first)(), (0, _operators.switchMap)(([nonce, header]) => {
        // setup our options (same way as in signAndSend)
        const eraOptions = (0, _classPrivateFieldLooseBase2.default)(this, _makeEraOptions)[_makeEraOptions](allOptions, {
          header,
          nonce
        });

        const signOptions = (0, _classPrivateFieldLooseBase2.default)(this, _makeSignOptions)[_makeSignOptions](eraOptions, {}); // add a fake signature to the extrinsic


        this.signFake(address, signOptions);
        return api.rpc.payment.queryInfo(this.toHex());
      })))();
    } // sign a transaction, returning the this to allow chaining, i.e. .sign(...).send()


    sign(account, optionsOrNonce) {
      super.sign(account, (0, _classPrivateFieldLooseBase2.default)(this, _makeSignOptions)[_makeSignOptions]((0, _classPrivateFieldLooseBase2.default)(this, _optionsOrNonce)[_optionsOrNonce](optionsOrNonce), {}));
      return this;
    } // signs a transaction, returning `this` to allow chaining. E.g.: `sign(...).send()`
    //
    // also supports signing through external signers


    signAsync(account, optionsOrNonce) {
      return decorateMethod(() => (0, _classPrivateFieldLooseBase2.default)(this, _observeSign)[_observeSign](account, optionsOrNonce).pipe((0, _operators.mapTo)(this)))();
    } // signAndSend with an immediate Hash result


    // signAndSend implementation for all 3 cases above
    signAndSend(account, optionsOrStatus, optionalStatusCb) {
      const [options, statusCb] = (0, _classPrivateFieldLooseBase2.default)(this, _makeSignAndSendOptions)[_makeSignAndSendOptions](optionsOrStatus, optionalStatusCb);

      const isSubscription = api.hasSubscriptions && ((0, _classPrivateFieldLooseBase2.default)(this, _ignoreStatusCb)[_ignoreStatusCb] || !!statusCb);
      return decorateMethod(() => (0, _classPrivateFieldLooseBase2.default)(this, _observeSign)[_observeSign](account, options).pipe((0, _operators.switchMap)(updateId => isSubscription ? (0, _classPrivateFieldLooseBase2.default)(this, _observeSubscribe)[_observeSubscribe](updateId) : (0, _classPrivateFieldLooseBase2.default)(this, _observeSend)[_observeSend](updateId))) // FIXME This is wrong, SubmittableResult is _not_ a codec
      )(statusCb);
    } // send with an immediate Hash result


    // send implementation for both immediate Hash and statusCb variants
    send(statusCb) {
      const isSubscription = api.hasSubscriptions && ((0, _classPrivateFieldLooseBase2.default)(this, _ignoreStatusCb)[_ignoreStatusCb] || !!statusCb);
      return decorateMethod(isSubscription ? (0, _classPrivateFieldLooseBase2.default)(this, _observeSubscribe)[_observeSubscribe] : (0, _classPrivateFieldLooseBase2.default)(this, _observeSend)[_observeSend])(statusCb);
    }

  }, _ignoreStatusCb = (0, _classPrivateFieldLooseKey2.default)("ignoreStatusCb"), _getPrelimState = (0, _classPrivateFieldLooseKey2.default)("getPrelimState"), _makeEraOptions = (0, _classPrivateFieldLooseKey2.default)("makeEraOptions"), _makeSignOptions = (0, _classPrivateFieldLooseKey2.default)("makeSignOptions"), _makeSignAndSendOptions = (0, _classPrivateFieldLooseKey2.default)("makeSignAndSendOptions"), _observeSign = (0, _classPrivateFieldLooseKey2.default)("observeSign"), _observeStatus = (0, _classPrivateFieldLooseKey2.default)("observeStatus"), _observeSend = (0, _classPrivateFieldLooseKey2.default)("observeSend"), _observeSubscribe = (0, _classPrivateFieldLooseKey2.default)("observeSubscribe"), _optionsOrNonce = (0, _classPrivateFieldLooseKey2.default)("optionsOrNonce"), _signViaSigner = (0, _classPrivateFieldLooseKey2.default)("signViaSigner"), _updateSigner = (0, _classPrivateFieldLooseKey2.default)("updateSigner"), _temp;
}