"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = createSubmittable;

var _createClass = _interopRequireDefault(require("./createClass"));

// Copyright 2017-2020 @polkadot/api authors & contributors
// This software may be modified and distributed under the terms
// of the Apache-2.0 license. See the LICENSE file for details.
let Submittable;

function createSubmittable(apiType, api, decorateMethod) {
  return extrinsic => {
    // This is not great, but basically what we do here is to only require the
    // class right at the point it is actually needed - delaying initialization
    if (!Submittable) {
      Submittable = (0, _createClass.default)({
        api,
        apiType,
        decorateMethod
      });
    }

    return new Submittable(api.registry, extrinsic);
  };
}